IMPLEMENTATION MODULE MainWnd;


FROM Windows IMPORT
     HANDLE, WM_DESTROY, HWND, NULL,
     PostQuitMessage;

IMPORT Event;
 
(*---------------------------------------------------------*)

PROCEDURE Init( AppName    : ARRAY OF CHAR; 
                NumActions : CARDINAL;
                Register   : REGISTERPROC; 
                Create     : CREATEPROC;
                Instance, PrevInstance : HANDLE) : HWND ;
                        
   VAR hWnd : HWND ;                
         
   BEGIN
      Actions := Event.Init( NumActions ) ;
      IF Actions = NIL THEN RETURN NULL; END ;
      Event.Register( Actions, WM_DESTROY, Destroy ) ;
      IF PrevInstance = 0 THEN
         IF Register(Instance) = NULL THEN
            RETURN NULL ;
         END; (* if *)
      END; (* if *)
      hWnd := Create( AppName, Instance ) ;
      RETURN hWnd ;
   END Init;

(*--------------------------------------------------------*)
(* This procedure responds to the WM_DESTROY message.     *)
(*                                                        *)
PROCEDURE Destroy( hWnd         : HANDLE;
                   wMsg, wParam : CARDINAL;
                   lParam       : LONGINT ) [LONG];
   BEGIN
      PostQuitMessage(0) ;
   END Destroy;
   
(*--------------------------------------------------------*)

PROCEDURE WindowProc ['WindowProc'] 
          ( hWnd         : HANDLE; 
            wMsg, wParam : CARDINAL;
            lParam       : LONGINT ) : LONGINT [WINDOWS, LONG] ;
   BEGIN
       RETURN Event.Respond( Actions, hWnd, wMsg, wParam, lParam) ; 
   END WindowProc;        
   
END MainWnd.
