LISTING 12: SCRIBBLE.DEF

DEFINITION MODULE Scribble;
FROM Windows IMPORT 
     HANDLE, LPSTR ;
PROCEDURE Initialize ['Scribble'] ;
PROCEDURE WinMain ['WinMain'] 
        ( Instance     : HANDLE ;
          PrevInstance : HANDLE ;
          CmdLine      : LPSTR ;
          CmdShow      : INTEGER) : INTEGER ;
END Scribble.


LISTING 13: SCRIBBLE.MOD

IMPLEMENTATION MODULE Scribble ;
FROM SYSTEM  IMPORT ADDRESS;
FROM Windows IMPORT 
     HANDLE, LPSTR, NULL, WM_LBUTTONDOWN, WM_MOUSEMOVE, MK_LBUTTON, POINT,
     HWND, HDC,
     MoveTo, LineTo, ReleaseDC, GetDC, ShowWindow, UpdateWindow;
FROM Error IMPORT RuntimeError;
FROM MsgLoops IMPORT DoMessage;
IMPORT Event;
IMPORT MainWnd;
IMPORT PlainCls;
VAR
   hWnd   : HWND ;
   LastPt : POINT ;
(*----------------------------------------------------------*)
(* Program execution starts here.                           *)
PROCEDURE WinMain ['WinMain']
        ( Instance     : HANDLE ;
          PrevInstance : HANDLE ;
          CmdLine      : LPSTR  ;
          CmdShow      : INTEGER ) : INTEGER ;
  BEGIN
      (* All modules must be initialize before any thing else is done.*)
      Initialize();
      (* Register the Window Class and Create the Window. *)
      hWnd := PlainCls.Init('Scribble', 5, Instance, PrevInstance ) ;
      IF hWnd = 0 THEN
         RuntimeError( 0, 'Error Creating Window!') ;
      END; (*if*)
      (* Add the response procedures to the List Actions. *)
      Event.Register( MainWnd.Actions, WM_LBUTTONDOWN, Mark );
      Event.Register( MainWnd.Actions, WM_MOUSEMOVE, Draw ) ;
      (* Show the Window. *)
      ShowWindow( hWnd, CmdShow );
      UpdateWindow( hWnd ) ;
      (* Start responding to messages. *)
      RETURN DoMessage() ;
  END WinMain.
(*-------------------------------------------------------------*)
PROCEDURE Mark( hWnd     : HANDLE; 
                wMsg     : CARDINAL;
                ModKeys  : CARDINAL;
                Location : LONGINT ) [LONG];
   BEGIN
       LastPt := Location:POINT ;
   END Mark;                        
(*-----------------------------------------------------------*)
PROCEDURE Draw( hWnd     : HANDLE; 
                wMsg     : CARDINAL;
                ModKeys  : CARDINAL;
                Location : LONGINT ) [LONG];
   VAR hDC : HDC ;                  
   BEGIN
       IF ModKeys = MK_LBUTTON THEN
          hDC := GetDC( hWnd ) ;
          MoveTo( hDC, LastPt.x, LastPt.y );
          LineTo( hDC, Location:POINT.x, Location:POINT.y );
          (* For a neat effect, remove the next two lines! *)
          LastPt.x := Location:POINT.x ;
          LastPt.y := Location:POINT.y ;
          ReleaseDC( hWnd, hDC ); 
       END;
   END Draw;               
END Scribble.                                               


LISTING 14: SCRIBBLE.LNK

C:\SBM2DOS\WINSTART.OBJ+
OBJ\Scribble.OBJ+
OBJ\MsgLoops.OBJ+
OBJ\Event.OBJ+
OBJ\MainWnd.OBJ+
OBJ\PlainCls.OBJ
Scribble/al:16/SEG:1024
Scribble/MAP/LINE
C:\SBM2DOS\M2LIBWIN+PASLIBW
DEF\Scribble.EDF
